
function removetabs_setting_startup(){
	removetabs_setting_load();
}

function removetabs_setting_accept(){
	removetabs_setting_save();
	return true;
}

function removetabs_setting_load(){
	var prefElements = document.getElementsByAttribute("prefelement", "true");
	
	for(var i=0; i<prefElements.length; i++){
		var prefElement = prefElements[i];
		var prefString = prefElement.getAttribute("prefstring");
		var prefAttribute = prefElement.getAttribute("prefattribute");

		var prefValue = removetabs_getPrefValue(prefString);

		prefElement[prefAttribute] = prefValue;
		prefElement.setAttribute(prefAttribute, prefValue);
	}
}

function removetabs_setting_save(){
	var prefElements = document.getElementsByAttribute("prefelement", "true");
	
	for(var i=0; i<prefElements.length; i++){
		var prefElement = prefElements[i];
		var prefString = prefElement.getAttribute("prefstring");
		var prefAttribute = prefElement.getAttribute("prefattribute");

		var prefValue = prefElement[prefAttribute];
		var prefLastValue = removetabs_getPrefValue(prefString);
		var prefType = typeof(removetabs_getDefaultValue(prefString));

		if(prefType == "number"){
			prefValue = parseInt(prefValue);
			if(isNaN(prefValue)) { prefValue = prefLastValue; }
		}

		if(prefValue != prefLastValue) {
			removetabs_setting_setPrefValue(prefString, prefValue);
		}
	}
	
	removetabs_removeMenuItem();
	removetabs_addMenuItems();
}

function removetabs_removeMenuItem() {
	// _CAO͒ gBrowser ͂ƂȂ
	var browser = Components.classes["@mozilla.org/appshell/window-mediator;1"]
		.getService(Components.interfaces.nsIWindowMediator)
		.getMostRecentWindow("navigator:browser")
		.getBrowser();
	
	removetabs_removeElement(browser, "tab-removeleftmenu");
	removetabs_removeElement(browser, "tab-removerightmenu");
	removetabs_removeElement(browser, "tab-removeallmenu");
	removetabs_addMenuItems(browser);
}

function removetabs_removeElement(browser, id) {
	var item = browser.ownerDocument.getElementById(id);
	if(item == null){ return; }
	item.parentNode.removeChild(item);
}

function removetabs_setting_setPrefValue(aPrefString, aPrefValue) {
	var defaultValue = removetabs_getDefaultValue(aPrefString);

	switch(typeof(defaultValue)){
		case "boolean":
			removetabs_pref_branch.setBoolPref(aPrefString, aPrefValue);
			break;
		case "number":
			removetabs_pref_branch.setIntPref(aPrefString, aPrefValue);
			break;
		case "string":
			removetabs_pref_branch.setCharPref(aPrefString, aPrefValue);
			break;
	}
}
